# -*- coding: utf-8 -*-
#
# Copyright (c) 2020, HILSTER GmbH, Germany - https://hilster.io
# All rights reserved.
#
# This file was generated by wrappergenerator.py
#

from __future__ import absolute_import, division, print_function, unicode_literals

from oser.core import BDouble as _BDouble
from oser.core import BFloat as _BFloat
from oser.core import BitField as _BitField
from oser.core import Flag as _Flag
from oser.core import LDouble as _LDouble
from oser.core import LFloat as _LFloat
from oser.core import Nibble as _Nibble
from oser.core import SBInt16 as _SBInt16
from oser.core import SBInt32 as _SBInt32
from oser.core import SBInt64 as _SBInt64
from oser.core import SBInt8 as _SBInt8
from oser.core import SLInt16 as _SLInt16
from oser.core import SLInt32 as _SLInt32
from oser.core import SLInt64 as _SLInt64
from oser.core import SLInt8 as _SLInt8
from oser.core import UBInt16 as _UBInt16
from oser.core import UBInt32 as _UBInt32
from oser.core import UBInt64 as _UBInt64
from oser.core import UBInt8 as _UBInt8
from oser.core import ULInt16 as _ULInt16
from oser.core import ULInt32 as _ULInt32
from oser.core import ULInt64 as _ULInt64
from oser.core import ULInt8 as _ULInt8


class BDouble(_BDouble):
    """
    Big endian 64-Bit float.
    """

    def __init__(self, value=0.0):
        """
        Args:
            value=0.0: the initial value.
        """
        super(BDouble, self).__init__(value=value)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(BDouble, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(BDouble, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(BDouble, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(BDouble, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(BDouble, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(BDouble, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(BDouble, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(BDouble, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(BDouble, self).up()


class BFloat(_BFloat):
    """
    Big endian 32-Bit float.
    """

    def __init__(self, value=0.0):
        """
        Args:
            value=0.0: the initial value.
        """
        super(BFloat, self).__init__(value=value)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(BFloat, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(BFloat, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(BFloat, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(BFloat, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(BFloat, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(BFloat, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(BFloat, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(BFloat, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(BFloat, self).up()


class BitField(_BitField):
    """
    N-Bit value with a variable length in a bit context.
    """

    def __init__(self, value=0, length=1, format=None):
        """
        Initialize a ``BitField``.

        Args:
            value=0 (int): the initial value
            length=1 (int): the length in bits
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(BitField, self).__init__(value=value, length=length, format=format)

    def byte_size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(BitField, self).byte_size()

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bits that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bits that were decoded.
        """
        return super(BitField, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(BitField, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(BitField, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(BitField, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(BitField, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(BitField, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(BitField, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the size in bits.

        Returns:
            int: the length of the bit type in bits.
        """
        return super(BitField, self).size()

    def up(self):
        """
        Return the parent element.
        """
        return super(BitField, self).up()


class Flag(_Flag):
    """
    1-Bit value used as a flag in a bit context.
    """

    def __init__(self, value=False, format=None):
        """
        Args:
            value=False (bool): can be ``True`` or ``False``.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(Flag, self).__init__(value=value, format=format)

    def byte_size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(Flag, self).byte_size()

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bits that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bits that were decoded.
        """
        return super(Flag, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be
                encoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            bytes: the encoded binary string.
        """
        return super(Flag, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(Flag, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(Flag, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(Flag, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(Flag, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(Flag, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the size in bits.

        Returns:
            int: the length of the bit type in bits.
        """
        return super(Flag, self).size()

    def up(self):
        """
        Return the parent element.
        """
        return super(Flag, self).up()


class LDouble(_LDouble):
    """
    Little endian 64-Bit float.
    """

    def __init__(self, value=0.0):
        """
        Args:
            value=0.0: the initial value.
        """
        super(LDouble, self).__init__(value=value)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(LDouble, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(LDouble, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(LDouble, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(LDouble, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(LDouble, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(LDouble, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(LDouble, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(LDouble, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(LDouble, self).up()


class LFloat(_LFloat):
    """
    Little endian 32-Bit float.
    """

    def __init__(self, value=0.0):
        """
        Args:
            value=0.0: the initial value.
        """
        super(LFloat, self).__init__(value=value)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(LFloat, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(LFloat, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(LFloat, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(LFloat, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(LFloat, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(LFloat, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(LFloat, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(LFloat, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(LFloat, self).up()


class Nibble(_Nibble):
    """
    4-Bit value in a bit context.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(Nibble, self).__init__(value=value, format=format)

    def byte_size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(Nibble, self).byte_size()

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bits that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bits that were decoded.
        """
        return super(Nibble, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be
                encoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            bytes: the encoded binary string.
        """
        return super(Nibble, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(Nibble, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(Nibble, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(Nibble, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(Nibble, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(Nibble, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the size in bits.

        Returns:
            int: the length of the bit type in bits.
        """
        return super(Nibble, self).size()

    def up(self):
        """
        Return the parent element.
        """
        return super(Nibble, self).up()


class SBInt16(_SBInt16):
    """
    Signed, bit endian 16-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(SBInt16, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(SBInt16, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(SBInt16, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(SBInt16, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(SBInt16, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(SBInt16, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(SBInt16, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(SBInt16, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(SBInt16, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(SBInt16, self).up()


class SBInt32(_SBInt32):
    """
    Signed, big endian 32-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(SBInt32, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(SBInt32, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(SBInt32, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(SBInt32, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(SBInt32, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(SBInt32, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(SBInt32, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(SBInt32, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(SBInt32, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(SBInt32, self).up()


class SBInt64(_SBInt64):
    """
    Signed, big endian 64-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(SBInt64, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(SBInt64, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(SBInt64, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(SBInt64, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(SBInt64, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(SBInt64, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(SBInt64, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(SBInt64, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(SBInt64, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(SBInt64, self).up()


class SBInt8(_SBInt8):
    """
    Signed, big endian 8-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(SBInt8, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(SBInt8, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(SBInt8, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(SBInt8, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(SBInt8, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(SBInt8, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(SBInt8, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(SBInt8, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(SBInt8, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(SBInt8, self).up()


class SLInt16(_SLInt16):
    """
    Signed, little endian 16-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(SLInt16, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(SLInt16, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(SLInt16, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(SLInt16, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(SLInt16, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(SLInt16, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(SLInt16, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(SLInt16, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(SLInt16, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(SLInt16, self).up()


class SLInt32(_SLInt32):
    """
    Signed, little endian 32-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(SLInt32, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(SLInt32, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(SLInt32, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(SLInt32, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(SLInt32, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(SLInt32, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(SLInt32, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(SLInt32, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(SLInt32, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(SLInt32, self).up()


class SLInt64(_SLInt64):
    """
    Signed, little endian 64-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(SLInt64, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(SLInt64, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(SLInt64, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(SLInt64, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(SLInt64, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(SLInt64, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(SLInt64, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(SLInt64, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(SLInt64, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(SLInt64, self).up()


class SLInt8(_SLInt8):
    """
    Signed, little endian 8-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(SLInt8, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(SLInt8, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(SLInt8, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(SLInt8, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(SLInt8, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(SLInt8, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(SLInt8, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(SLInt8, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(SLInt8, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(SLInt8, self).up()


class UBInt16(_UBInt16):
    """
    Unsigned, big endian 16-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(UBInt16, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(UBInt16, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(UBInt16, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(UBInt16, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(UBInt16, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(UBInt16, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(UBInt16, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(UBInt16, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(UBInt16, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(UBInt16, self).up()


class UBInt32(_UBInt32):
    """
    Unsigned, big endian 32-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(UBInt32, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(UBInt32, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(UBInt32, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(UBInt32, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(UBInt32, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(UBInt32, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(UBInt32, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(UBInt32, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(UBInt32, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(UBInt32, self).up()


class UBInt64(_UBInt64):
    """
    Unsigned, big endian 64-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(UBInt64, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(UBInt64, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(UBInt64, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(UBInt64, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(UBInt64, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(UBInt64, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(UBInt64, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(UBInt64, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(UBInt64, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(UBInt64, self).up()


class UBInt8(_UBInt8):
    """
    Unsigned, big endian 8-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(UBInt8, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(UBInt8, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(UBInt8, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(UBInt8, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(UBInt8, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(UBInt8, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(UBInt8, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(UBInt8, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(UBInt8, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(UBInt8, self).up()


class ULInt16(_ULInt16):
    """
    Unsigned, little endian 16-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(ULInt16, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(ULInt16, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(ULInt16, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(ULInt16, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(ULInt16, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(ULInt16, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(ULInt16, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(ULInt16, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(ULInt16, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(ULInt16, self).up()


class ULInt32(_ULInt32):
    """
    Unsigned, little endian 32-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(ULInt32, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(ULInt32, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(ULInt32, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(ULInt32, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(ULInt32, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(ULInt32, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(ULInt32, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(ULInt32, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(ULInt32, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(ULInt32, self).up()


class ULInt64(_ULInt64):
    """
    Unsigned, little endian 64-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(ULInt64, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(ULInt64, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(ULInt64, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(ULInt64, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(ULInt64, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(ULInt64, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(ULInt64, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(ULInt64, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(ULInt64, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(ULInt64, self).up()


class ULInt8(_ULInt8):
    """
    Unsigned, little endian 8-Bit integer.
    """

    def __init__(self, value=0, format=None):
        """
        Args:
            value: the initial value.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(ULInt8, self).__init__(value=value, format=format)

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(ULInt8, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(ULInt8, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(ULInt8, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(ULInt8, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(ULInt8, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(ULInt8, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(ULInt8, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(ULInt8, self).size()

    byte_size = size

    def up(self):
        """
        Return the parent element.
        """
        return super(ULInt8, self).up()

